package com.example.base;

import com.example.enums.ResultEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;


/**
 * @author xiezt
 */
@Data
@ApiModel(value = "接口返回信息", description = "接口返回信息")
public class RetHead extends BaseEntity {

    public RetHead() {

    }

    public RetHead(ResultEnum resultEnum) {
        this.errCode = Short.valueOf(resultEnum.getCode().toString());
        this.errMsg = resultEnum.getMsg();
    }

    @ApiModelProperty(value = "返回响应码", example = "返回响应码")
    private short errCode;

    @ApiModelProperty(value = "返回响应信息", example = "返回响应信息")
    private String errMsg;

    @ApiModelProperty(value = "总记录数")
    private Long total = 0L;


}
