package com.example.controller;

import com.alibaba.fastjson.JSON;
import com.example.base.BaseController;
import com.example.base.ResponseBase;
import com.example.base.ResultVO;
import com.example.entity.OmsOrder;
import com.example.enums.PayStatusEnum;
import com.example.enums.ResultEnum;
import com.example.util.RedisUtil;
import com.example.util.SnowFlake;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigDecimal;
import java.util.Date;

@Slf4j
@RestController
@RequestMapping("/order")
@Api(tags = "创建订单")
public class OrderController extends BaseController {

    private final static String OMSORDER = "oms_order_";

    @Autowired
    private RedisUtil redisUtil;

    @ApiOperation(value = "创建订单")
    @PostMapping("/createOrder")
    public ResponseBase createOrder() {
        SnowFlake generatorIdUtils = new SnowFlake(2,3);
        String orderId = generatorIdUtils.nextId()+"";
        OmsOrder order = new OmsOrder();
        order.setId(orderId);
        order.setProductId("23");
        order.setCreateDate(new Date());
        order.setStatus(PayStatusEnum.INIT.getIndex());
        order.setOrderId(orderId);
        order.setPayAmount(new BigDecimal(1));
        order.setDiscountAmount(new BigDecimal(0));
        order.setTotalAmount(new BigDecimal(1));
        order.setProductName("商品测试");
        order.setUserId(111L);
        redisUtil.set(OMSORDER + orderId, order);
        OmsOrder omsOrder = JSON.parseObject(redisUtil.get(OMSORDER + orderId).toString(),OmsOrder.class);
        return responseSuccess(new ResultVO(ResultEnum.SUCCESS,omsOrder));
    }


}
